1000 REMark EDT_CONFIG - Screen Text editor configurator - version 3.06K
1010 REMark  v2.10 - June 1986,  Chas Dillon
1020 REMark v3.06K - March 2002,  Mark Knight
1030 :
1040 TURBO_objfil "ram1_Edt_Config"
1050 TURBO_locstr "I"
1060 TURBO_taskn "EdtCfg3.06K"
1070 DATA_AREA 6
1080 :
1090 REMark extra commands/functions : DEVICE_STATUS
1100 REMark                            POSITION, SET_POSITION, ALLOCATION
1110 REMark                            CURSOR_OFF, CURSOR_ON
1120 REMark                            PEEK$, POKE$, TYPE_IN, COMMAND_LINE
1130 REMark                            FWINDOW% - MK - Added November 1999
1140 :
1150 IMPLICIT% ii,jj, key
1160 MANIFEST : TRUE%       = 1     : FALSE%     = 0
1170 REMark - MK - Restart% added below, July 2000
1180 MANIFEST : err_cab%    = 2     : Restart%   = -32768
1190 :
1200 DIM vers$(6) : vers$ = '3.06K'
1210 IF COMPILED
1220   OPEN #0,'con_450x200a16x22'
1230   MODE 4
1240   OPEN #1,'con_450x200a16x22'
1250 END IF 
1260 :
1270 Wrong% = FALSE%
1280 Initialise
1290 REPeat retry_lp
1300   IF Wrong% : EXIT retry_lp
1310   Set_up_Parameters
1320   IF Wrong% : EXIT retry_lp
1330   Re_Write_Program
1340   IF NOT Wrong% : EXIT retry_lp
1350   IF Wrong% = err_cab% : EXIT retry_lp
1360 END REPeat retry_lp
1370 IF Wrong% = Restart% THEN RUN
1380 IF Wrong%<>0 THEN PAUSE 100
1390 Shutdown
1400 STOP
1410 :
1420 DEFine PROCedure Initialise
1430   Find_SCREENSIZE
1440   basic_data_space = 15.5  : REMark Basic data space for EDITOR - MK -
1450   array_base%  = 1         : REMark lowest subscript on char arrays
1460   max_deep%=ScreenHeight%-1: REMark Max no of vert. pixels - MK -
1470   min_depth%   = 8         : REMark least number of screen lines - MK -
1480   max_wide%=ScreenWidth%-2 : REMark Max no of horiz pixels - MK -
1490   min_width%   = 31        : REMark least no. of screen cols - MK -
1500   chi_pix%     = 10        : REMark no. of vert. pixels per char
1510   cwd_pix%     = 6         : REMark no. of horiz. pixels per char
1520   search_max%  = 3         : REMark max no of compound search strings
1530   :
1540   length_of_paras = 350    : REMark Amount of configurable stuff
1550   :
1560   REMark ______________  Global string constants ___________________
1570   DIM word_delim$(30), word_markers$(30), help_name$(36)
1580   DIM prog_name$(36)
1590   :
1600   REMark ______________  Global string variables ___________________
1610   DIM key_bffr$(80)
1620   DIM yn$(2), device$(6+27), file_name$(50), ip_str$(200)
1630   DIM wrk$(60), dvc$(6+27), dflt_dvc$(6+27), boot_name$(36)
1640   :
1650   REMark ______________  Supercharge req'mts ___________________
1660   DIM msg$(2), str$(2), dflt$(2)
1670   :
1680   key_bffr$ = ""   : ip_str$ = ""
1690   prog_name$ = "Editor"
1700   REMark  ____________  Figurative constants  _________________________
1710   REMark  - MK - Changed from assignments to MANIFEST constants for Turbo
1720   :
1730   MANIFEST : ENTER%      =  10
1740   MANIFEST : ESC%        =  27
1750   MANIFEST : SPACE_shift%= 252
1760   MANIFEST : lf_arrow%   = 192  : rt_arrow%   = 200
1770   MANIFEST : lf_alt%     = 193  : rt_alt%     = 201
1780   MANIFEST : up_arrow%   = 208  : dn_arrow%   = 216
1790   MANIFEST : scroll_up%  = 209  : scroll_dn%  = 217
1800   MANIFEST : del_lf%     = 194  : del_rt%     = 202
1810   MANIFEST : del_stol%   = 195  : del_ndol%   = 203
1820   :
1830   MANIFEST : err_syn% = 1
1840   MANIFEST : err_nex% = 5
1850   MANIFEST : err_tex% = 6
1860   MANIFEST : err_ltl% = 7
1870   MANIFEST : err_oom% = 9
1880   MANIFEST : err_fnf% = 12
1890   MANIFEST : err_cof% = 13
1900   MANIFEST : err_ntb% = 17
1910   MANIFEST : err_nts% = 18
1920   MANIFEST : err_msp% = 19
1930   MANIFEST : err_bfn% = 20
1940   MANIFEST : err_nef% = 21
1950   MANIFEST : err_oor% = 22
1960   MANIFEST : err_wrv% = 23
1970   :
1980   REMark  ------  Program control variables  ---------------------------
1990   :
2000   Wrong% = FALSE%
2010   lin% = 0           :  col% = 0
2020   :
2030   REMark  -------------------------------------------------------------
2040   Announce
2050   REMark - MK - Put the WINDOW in the middle of the screen, however big it is
2060   hz_pixels% = 484 : vt_pixels% = 242 : hz_off% = (ScreenWidth% - hz_pixels%) DIV 2 : vt_off% = (ScreenHeight% - vt_pixels%) DIV 2
2070   depth% = 24 : width% = 80 : max_ch% = 40
2080   Show_Banner
2090   Get_IP_File
2100 END DEFine 
2110 :
2120 DEFine PROCedure Show_Banner
2130   WINDOW#0; ScreenWidth%,ScreenHeight%,0,0 : PAPER #0;0 : CLS#0
2140   WINDOW    ScreenWidth%,ScreenHeight%,0,0 : PAPER    0 : CLS
2150   Reset_Main_Window
2160   PAPER 2 : INK 7
2170   PRINT " EDITOR Configure version ";vers$;" - Chas Dillon  1986/7, Mark Knight  1999-2002";
2180   CLS 4 : PAPER 0 : INK 4
2190 END DEFine 
2200 :
2210 DEFine PROCedure Set_up_Parameters
2220   Unload_Parameters
2230   AT 4,0 : PAPER 0 : INK 4 : CLS 2
2240   old_mode% = scr_mode%
2250   scr_mode% = Specified_Number%(7,(scr_mode%),"Enter the run-time screen mode (4 or 8): ",4,8,1)
2260   IF scr_mode% = 4
2270     wd_pix% = 6 : ELSE 
2280     wd_pix% = 12
2290     IF old_mode% <> scr_mode% : scr_width% = scr_width% DIV 2
2300   END IF 
2310   REPeat par_lp
2320     insert_mode% = Specified_Number%(9,(insert_mode%),"Enter the data entry mode (0,1 = Over,Insert): ",0,1,1)
2330     scr_pan% = Specified_Number%(11,(scr_pan%),"Enter the horiz. pan percentage (10 to 90): ",10,90,0)
2340     cursor_delay% = Specified_Number%(12,(cursor_delay%),"Enter the cursor speed (1 to 3000; 1=fast): ",1,3000,0)
2350     block_type% = Specified_Number%(14,(block_type%),"Enter the block type (1=Char,2=Col,3=Line): ",1,3,0)
2360     block_show% = Specified_Number%(15,(block_show%),"Enter the block visibility (0=Hide;1=Show): ",0,1,1)
2370     lin% = 22 : yn$ = Text_Response$("y","                   Confirm these are OK (n/y): ")
2380     IF yn$ == "y" : EXIT par_lp
2390   END REPeat par_lp
2400   AT 1,0 : PAPER 0 : INK 4 : CLS 2
2410   Specify_Colours
2420   REPeat par_lp
2430     AT 1,0 : PAPER 0 : INK 7 : CLS 2
2440     PRINT \"The following values SIGNIFICANTLY affect program operation - ALTER WITH CARE" : INK 4
2450     char_max%     = Specified_Number%(4,(char_max%),"Enter the maximum line length: ",20,1000,0)
2460     data_max%     = Max_Short%(256, char_max%)
2470     tab_stop%     = Specified_Number%(5,(tab_stop%),"Enter the tabbing interval: ",1,(char_max%-1),0)
2480     right_margin% = Specified_Number%(6,(right_margin%),"Enter the column of the right hand margin: ",1,(char_max%),0)
2490     wd_pix%       = Specified_Number%(8,(wd_pix%),"Enter the character width in pixels: ",6,12,0)
2500     hi_pix%       = Specified_Number%(9,(hi_pix%),"Enter the character height in pixels: ",8,10,0)
2510     search_max%   = Specified_Number%(11,(search_max%),"Enter the max no of concurrent search strings: ",1,6,0)
2520     str_max%      = Specified_Number%(12,(str_max%),"Enter the max length of a search string: ",40,256,0)
2530     file_name$    = Specified_String$(14,(file_name$),"Enter the name of the character set file: ",1,36)
2540     help_name$    = Specified_String$(15,(help_name$),"Enter the name of the help file: ",1,36)
2550     boot_name$    = Specified_String$(16,(boot_name$),"Enter the name of the boot command file: ",1,36)
2560     device$ = Specified_Device$(17,(device$),"Enter the device which will hold these files: ")
2570     dflt_dvc$ = Specified_Device$(18,(dflt_dvc$),"Enter the run-time default data device: ")
2580     word_delim$   = Specified_String$(20,(word_delim$),"Enter the word delimiters for cursor movement: ",1,30)
2590     word_markers$ = Specified_String$(21,(word_markers$),"Enter the word delimiters for string search: ",1,30)
2600     lin% = 23 : yn$ = Text_Response$("y","                   Confirm these are OK (n/y): ")
2610     IF yn$ == "y" : EXIT par_lp
2620   END REPeat par_lp
2630   AT 1,0 : PAPER 0 : INK 4 : CLS 2
2640   PRINT \\\\"    The following screen allows the sizing and positioning"
2650   PRINT    \"         of the screen area to be used by EDITOR - "
2660   PRINT \\\\"    The selection now is the default - it may be altered at run time"
2670   PRINT \\\\"    Press ENTER to continue " : IF LEN(INKEY$(#1,-1)) : END IF 
2680   Adjust_Screen
2690   Set_Screen_Format
2700   Load_Parameters
2710 END DEFine 
2720 :
2730 DEFine PROCedure Get_IP_File
2740   dvc$ = "flp2_"
2750   REPeat val_lp
2760     lin% = 4
2770     dvc$ = Text_Response$((dvc$), "Enter the name of the device which now holds 'Editor': ")
2780     IF LEN(dvc$) < 5
2790       Wrong% = err_syn% : ELSE 
2800       IF dvc$(5) <> "_"
2810         Wrong% = err_syn% : ELSE 
2820         Wrong% = File_not_Available% (3, (dvc$ & prog_name$), 0, 0)
2830         IF Wrong% = 0 : EXIT val_lp
2840       END IF : END IF 
2850     Display_Error
2860   END REPeat val_lp
2870   Clear_Error
2880   file_len = Input_Length(3)
2890   bffr_addr  = RESPR((length_of_paras+100))
2900   Get_Data_Point
2910   IF Wrong% : Display_Error
2920 END DEFine 
2930 :
2940 DEFine PROCedure Get_Data_Point
2950   LOCal x$(8), z, ii, located, skipper
2960   Find_VERSION
2970   IF Wrong%<>0 THEN CLOSE#3 : RETurn 
2980   SET_POSITION #3,13500 : located = 0 : skipper = 0
2990   REPeat find_banner
3000     IF EOF(#3) : Wrong% = err_nef% : EXIT find_banner
3010     IF NOT skipper : x$ = INKEY$(#3,-1)
3020     skipper = 0
3030     IF x$ <> "$" : NEXT find_banner
3040     x$ = INKEY$(#3,-1) : IF x$ <> "^" : skipper = 1 : NEXT find_banner
3050     x$ = INKEY$(#3,-1) : IF x$ <> "$" : NEXT find_banner
3060     located = POSITION(#3) : x$ = ""
3070     REMark CLS
3080     REMark PRINT located : PAUSE
3090     REMark COMMAND_LINE
3100     REMark TYPE_IN "Test$='':for n=1 to 400:test$=test$&inkey$(-1)"&CHR$(10)
3110     REMark TYPE_IN INPUT$(#3,400)
3120     REMark STOP
3130     ii = 0 : REPeat i_lp
3140       ii = ii + 1 : IF ii > 7 : EXIT i_lp
3150       x$ = x$ & INKEY$(#3,-1) : END REPeat i_lp
3160     IF x$ = "config " : EXIT find_banner
3170     IF LEN(x$) = 7 AND x$<>"config " THEN Wrong% = err_nef% : EXIT find_banner
3180     SET_POSITION #3,(located)
3190   END REPeat find_banner
3200   IF Wrong% : CLOSE #3 : RETurn 
3210   z = bffr_addr-1 : skipper = bffr_addr + length_of_paras
3220   REPeat i_lp
3230     z = z + 1 : IF z > skipper : EXIT i_lp
3240     POKE z,CODE(INKEY$(#3,-1)) : END REPeat i_lp
3250   CLOSE #3
3260   data_point = located+7
3270   para_base = bffr_addr
3280 END DEFine 
3290 :
3300 DEFine PROCedure Specify_Colours
3310   PRINT \\"Define screen colours:"
3320   PRINT \"                       0 = Black  2 = Red  4 = Green  7 = White "
3330   PRINT \"Current values are displayed in the following messages"
3340   PRINT
3350   REPeat val_lp
3360     AT 8,0 : PAPER 0 : INK 4 : CLS 2 : CLS 3
3370     Get_Colours "   Main screen",(paper1_colr%),(ink1_colr%)
3380     paper1_colr% = papcol% : ink1_colr% = inkcol%
3390     Get_Colours "Command screen",(paper2_colr%),(ink2_colr%)
3400     paper2_colr% = papcol% : ink2_colr% = inkcol%
3410     Get_Colours "  Error screen",(paper3_colr%),(ink3_colr%)
3420     paper3_colr% = papcol% : ink3_colr% = inkcol%
3430     PAPER paper1_colr% : INK ink1_colr%
3440     PRINT \\\"     Main screen     ";
3450     PAPER paper2_colr% : INK ink2_colr%
3460     PRINT    "   Command screen    ";
3470     PAPER paper3_colr% : INK ink3_colr%
3480     PRINT    "    Error screen     ";
3490     lin% = 16 : yn$ = Text_Response$("y","         Confirm these are OK (y/n): ")
3500     IF yn$ == "y" : EXIT val_lp
3510     END REPeat val_lp
3520 END DEFine 
3530 :
3540 DEFine FuNction Specified_Number%(lin%, dflt%, msg$, low%, high%, equal)
3550   LOCal wk%, wrk$(60), ii
3560   REPeat val_lp
3570     wrk$ = Text_Response$((dflt%),FILL$(" ",47-LEN(msg$))&msg$)
3580     IF LEN(wrk$)
3590       wk% = 0 : ii = 0
3600       REPeat i_lp
3610         ii = ii+1 : IF ii > LEN(wrk$) : EXIT i_lp
3620         IF (wrk$(ii) INSTR "0123456789") = 0 : wk% = 1 : EXIT i_lp
3630       END REPeat i_lp
3640       IF wk% = 0
3650         wk% = wrk$
3660         IF equal
3670           IF wk% = low% : EXIT val_lp
3680           IF wk% = high% : EXIT val_lp
3690           Wrong% = err_oor%
3700         ELSE 
3710           IF wk% < low%
3720             Wrong% = err_nts% : ELSE 
3730             IF wk% <= high%
3740               EXIT val_lp : ELSE 
3750               Wrong% = err_ntb% : END IF : END IF : END IF 
3760         ELSE : Wrong% = err_nex% : END IF 
3770       ELSE : Wrong% = err_nex% : END IF 
3780     Display_Error
3790   END REPeat val_lp
3800   Clear_Error
3810   RETurn wk%
3820 END DEFine 
3830 :
3840 DEFine FuNction Specified_String$(lin%, dflt$, msg$, low%, high%)
3850   LOCal wrk$(60)
3860   REPeat val_lp
3870     wrk$ = Text_Response$((dflt$),FILL$(" ",47-LEN(msg$))&msg$)
3880     IF LEN(wrk$) >= low% AND LEN(wrk$) <= high% AND wrk$<>FILL$(" ",LEN(wrk$)) : EXIT val_lp
3890     IF LEN(wrk$) : Wrong% = err_ltl% : ELSE : Wrong% = err_tex%
3900     Display_Error
3910     AT lin%+1,0 : PAPER 0 : CLS 4
3920     END REPeat val_lp
3930   Clear_Error
3940   RETurn wrk$
3950 END DEFine 
3960 :
3970 DEFine FuNction Specified_Device$(lin%,dflt$,msg$)
3980   REPeat val_lp
3990     wrk$ = Text_Response$((dflt$),FILL$(" ",47-LEN(msg$))&msg$)
4000     IF LEN(wrk$) = 5
4010       IF wrk$(5) = "_" AND wrk$(4) > "0" AND wrk$(4) < "9" : EXIT val_lp
4020       END IF 
4030     Wrong% = err_syn%
4040     Display_Error
4050     END REPeat val_lp
4060   Clear_Error
4070   RETurn wrk$
4080 END DEFine 
4090 :
4100 DEFine PROCedure Unload_Parameters
4110   char_max%     = Up_Para%(0)
4120   orig_char_max%= Max_Short%(256, char_max%)
4130   scr_depth%    = Up_Para%(2)
4140   scr_width%    = Up_Para%(4)
4150   scr_vt_off%   = Up_Para%(6)
4160   scr_hz_off%   = Up_Para%(8)
4170   paper1_colr%  = Up_Para%(10)
4180   paper2_colr%  = Up_Para%(12)
4190   paper3_colr%  = Up_Para%(14)
4200   ink1_colr%    = Up_Para%(16)
4210   ink2_colr%    = Up_Para%(18)
4220   ink3_colr%    = Up_Para%(20)
4230   tab_stop%     = Up_Para%(22)
4240   right_margin% = Up_Para%(24)
4250   hi_pix%       = Up_Para%(26)
4260   wd_pix%       = Up_Para%(28)
4270   search_max%   = Up_Para%(30)
4280   str_max%      = Up_Para%(32)
4290   scr_mode%     = Up_Para%(34)
4300   insert_mode%  = Up_Para%(36)
4310   scr_pan%      = Up_Para%(38)
4320   block_type%   = Up_Para%(40)
4330   block_show%   = Up_Para%(42)
4340   cursor_delay% = Up_Para%(44)
4350   device$       = String_Para$(46)
4360   dflt_dvc$     = String_Para$(54)
4370   file_name$    = String_Para$(62)
4380   help_name$    = String_Para$(102)
4390   boot_name$    = String_Para$(142)
4400   word_delim$   = String_Para$(182)
4410   word_markers$ = String_Para$(214)
4420 END DEFine 
4430 :
4440 DEFine FuNction Up_Para%(off%)
4450   RETurn -PEEK_W(para_base+off%)-7096
4460 END DEFine 
4470 :
4480 DEFine PROCedure Dn_Para(off%,val%)
4490   POKE_W para_base+off%, -val%-7096
4500 END DEFine 
4510 :
4520 DEFine FuNction String_Para$(off%)
4530   LOCal lenf%
4540   lenf% = PEEK_W(para_base+off%)
4550   RETurn Stripped_Back$(PEEK$((para_base+off%+2),(lenf%)))
4560 END DEFine 
4570 :
4580 DEFine FuNction Stripped_Back$(str$)
4590   LOCal ii
4600   ii = LEN(str$) + 1
4610   REPeat back_lp
4620     ii = ii - 1 : IF ii < 1 : RETurn ""
4630     IF str$(ii) <> " " : RETurn str$(1 TO ii)
4640   END REPeat back_lp
4650 END DEFine 
4660 :
4670 DEFine FuNction Max_Short%(a%,b%)
4680   IF a% > b% : RETurn a% : ELSE : RETurn b%
4690 END DEFine 
4700 :
4710 REMark DEFine FuNction Min_Short%(a%,b%)
4720   REMark IF a% < b% : RETurn a% : ELSE : RETurn b%
4730 REMark END DEFine
4740 :
4750 DEFine PROCedure Load_Parameters
4760   Dn_Para 0, char_max%
4770   Dn_Para 2, scr_depth%
4780   Dn_Para 4, scr_width%
4790   Dn_Para 6, scr_vt_off%
4800   Dn_Para 8, scr_hz_off%
4810   Dn_Para 10, paper1_colr%
4820   Dn_Para 12, paper2_colr%
4830   Dn_Para 14, paper3_colr%
4840   Dn_Para 16, ink1_colr%
4850   Dn_Para 18, ink2_colr%
4860   Dn_Para 20, ink3_colr%
4870   Dn_Para 22, tab_stop%
4880   Dn_Para 24, right_margin%
4890   Dn_Para 26, hi_pix%
4900   Dn_Para 28, wd_pix%
4910   Dn_Para 30, search_max%
4920   Dn_Para 32, str_max%
4930   Dn_Para 34, scr_mode%
4940   Dn_Para 36, insert_mode%
4950   Dn_Para 38, scr_pan%
4960   Dn_Para 40, block_type%
4970   Dn_Para 42, block_show%
4980   Dn_Para 44, cursor_delay%
4990   Put_String  46,  6, (device$)
5000   Put_String  54,  6, (dflt_dvc$)
5010   Put_String  62,  37, (file_name$)
5020   Put_String  102, 37, (help_name$)
5030   Put_String  142, 37, (boot_name$)
5040   Put_String  182, 30, (word_delim$)
5050   Put_String  214, 30, (word_markers$)
5060 END DEFine 
5070 :
5080 DEFine PROCedure Put_String (off%, lenf%, str$)
5090   LOCal txt$(60)
5100   txt$ = str$ & FILL$(" ",lenf%-LEN(str$))
5110   POKE_W (para_base+off%), (lenf%)
5120   POKE$ (para_base+off%+2), (txt$)
5130 END DEFine 
5140 :
5150 DEFine PROCedure Re_Write_Program
5160   LOCal ii, t$(2), msga$(500), prog_base
5170   LOCal jj
5180   REPeat val_lp
5190     Show_Banner
5200     PRINT \\\\\"      Writing reconfigured program"
5210     Wrong% = File_not_Available%(3,(dvc$ & prog_name$),0,0)
5220     IF Wrong% <> 0 : Display_Error
5230     AT 17,0 : PAPER 0 : INK 4
5240     PRINT "Check/change volume; Press ENTER to continue, ESC to quit, other to restart"
5250     IF NOT Wrong% : CLOSE #3
5260     ii = CODE(INKEY$(#1,-1))
5270     IF ii<>ENTER% AND ii<>ESC% THEN 
5280       Wrong% = Restart%
5290       RETurn 
5300     END IF 
5310     IF ii = ENTER% AND Wrong% = 0
5320       Wrong% = File_not_Available%(3,(dvc$ & prog_name$),1,0)
5330       IF Wrong% = 0 : EXIT val_lp
5340       Display_Error : FOR jj=1 TO 1500 : END FOR jj : NEXT val_lp
5350       END IF 
5360     IF ii = ENTER% : NEXT val_lp
5370     Wrong% = err_ntb%
5380     IF ii = ESC% : Wrong% = err_cab%
5390     EXIT val_lp
5400     END REPeat val_lp
5410   IF Wrong% <> 0 : RETurn 
5420   x = 0
5430   IF orig_char_max% <> data_max%
5440     IF orig_char_max% > 256 OR char_max% > 256
5450       x = (char_max% - 256) * 12 + (str_max% - 60) * 4
5460       IF x < 0 : x = 2
5470       END IF : END IF 
5480   IF x
5490     x = x + basic_data_space * 1024
5500     prog_base = ALLOCATION(file_len)
5510     IF prog_base < 1
5520       Save_on_Small_mc : ELSE : Save_on_Big_mc : END IF 
5530   ELSE 
5540     Patch_File : END IF 
5550   IF NOT x : AT 20,10 : PRINT "End of task" : CLS 2
5560 END DEFine 
5570 :
5580 DEFine PROCedure Patch_File
5590   LOCal x
5600   OPEN #3,(dvc$ & prog_name$)
5610   SET_POSITION #3,(data_point)
5620   x = bffr_addr - 1
5630   REPeat i_lp
5640     x = x + 1 : IF x > bffr_addr+length_of_paras : EXIT i_lp
5650     PRINT #3,CHR$(PEEK(x)); : END REPeat i_lp
5660   CLOSE #3
5670 END DEFine 
5680 :
5690 DEFine PROCedure Save_on_Small_mc
5700   Patch_File
5710   t$ = CHR$(10)
5720   COMMAND_LINE
5730   TYPE_IN (FILL$(" ",350)&t$)
5740   msga$ = "ink#0,0" &t$& "paper#0,0" &t$
5750   msga$ = msga$ & "window 448,210,32,6:at 20,10" & t$
5760   msga$ = msga$ & "for a=1 to 2500:endfor a" &t$
5770   msga$ = msga$ & "a=respr(" & file_len & ")" &t$
5780   msga$ = msga$ & "lbytes " & dvc$ & prog_name$ & ",a:"
5790   msga$ = msga$ & "delete " & dvc$ & prog_name$ &t$
5800   msga$ = msga$ & "SEXEC " & dvc$ & prog_name$ & ",a," & file_len &","&x&t$
5810   msga$ = msga$ & "print'End of task - reset system':cls#0:ink#0,7" & t$ & t$
5820   TYPE_IN (msga$)
5830 END DEFine 
5840 :
5850 DEFine PROCedure Save_on_Big_mc
5860   LBYTES (dvc$ & prog_name$), prog_base
5870   DELETE (dvc$ & prog_name$)
5880   MOVE_MEMORY bffr_addr TO prog_base+data_point, length_of_paras
5890   SEXEC (dvc$ & prog_name$), prog_base, file_len, x
5900   x = 0
5910 END DEFine 
5920 :
5930 DEFine PROCedure Get_Colours (str$,papr%,inkk%)
5940   LOCal x$(4)
5950   PRINT " "\" ";: PAPER papr% : INK inkk% : CLS 3
5960   INPUT TO 20;(str$ & " paper: ");x$;
5970   papcol% = "0" & x$
5980   IF scr_mode% = 4 : papcol% = 2 * (papcol% DIV 2)
5990   IF LEN(x$) AND papcol% < 8 : ELSE : papcol% = papr%
6000   INPUT TO 45; "Ink: ";x$;
6010   inkcol% = "0" & x$
6020   IF scr_mode% = 4 : inkcol% = 2 * (inkcol% DIV 2)
6030   IF inkcol% <> papcol% AND LEN(x$) AND inkcol% < 8 : ELSE : inkcol% = inkk%
6040 END DEFine 
6050 :
6060 DEFine PROCedure Shutdown
6070   CURSOR_OFF
6080   BORDER 1,0: CLS
6090 END DEFine 
6100 :
6110 DEFine PROCedure Set_Screen_Format
6120   REMark Draw_Border
6130   Reset_Main_Window
6140 END DEFine 
6150 :
6160 DEFine PROCedure Reset_Main_Window
6170   CURSOR_OFF
6180   WINDOW   hz_pixels%,vt_pixels%,hz_off%,vt_off%
6190   WINDOW#0;hz_pixels%,vt_pixels%,hz_off%,vt_off%
6200   BORDER 1,7 : BORDER#0;1,7
6210   PAPER 0 : INK 4
6220 END DEFine 
6230 :
6240 DEFine PROCedure Reset_Error_Window
6250   CURSOR_OFF : WINDOW hz_pixels%-4,chi_pix%,hz_off%+2,1+vt_off%+chi_pix%*(depth%-1)
6260   PAPER 2 : INK 7
6270 END DEFine 
6280 :
6290 DEFine PROCedure Clear_Error
6300   Reset_Error_Window : PAPER 0 : CLS 4
6310   Wrong% = FALSE% : Reset_Main_Window
6320 END DEFine 
6330 :
6340 DEFine PROCedure Reset_Command_Window
6350   LOCal x%
6360   CURSOR_OFF
6370   WINDOW hz_pixels%-4, chi_pix%*txt_lines%, hz_off%+2, 1+vt_off%+chi_pix%*lin%
6380   PAPER 0 : INK 4 : CLS
6390   PRINT msg$;
6400   x% = LEN(msg$) MOD width%
6410   WINDOW txt_width%*cwd_pix%, chi_pix%*txt_lines%, 2+hz_off%+cwd_pix%*x%, 1+vt_off%+chi_pix%*lin%
6420   INK 7 : PRINT ip_str$;
6430 END DEFine 
6440 :
6450 DEFine FuNction Key_from_Keybd
6460   LOCal x$(2)
6470   IF LEN(key_bffr$)
6480     x$ = key_bffr$(array_base%)
6490     IF LEN(key_bffr$) > array_base%
6500       key_bffr$ = key_bffr$(array_base%+1 TO LEN(key_bffr$)) : ELSE 
6510       key_bffr$ = "" : END IF 
6520   ELSE 
6530     x$ = INKEY$(#1,-1)
6540   END IF 
6550   IF CODE(x$) = SPACE_shift% : x$ = " "
6560   RETurn CODE(x$)
6570 END DEFine 
6580 :
6590 DEFine PROCedure Adjust_Screen
6600   Find_SCREENSIZE
6610   Check_BOUNDS
6620   WINDOW#0;ScreenWidth%,ScreenHeight%,0,0
6630   PAPER 0 : INK 7
6640   REPeat chg_scrn
6650     scr_hz_pixels% = wd_pix% * scr_width%
6660     scr_vt_pixels% = hi_pix% * scr_depth%
6670     WINDOW 4+scr_hz_pixels%,2+scr_vt_pixels%+hi_pix%,scr_hz_off%-2,scr_vt_off%-1
6680     CLS : BORDER 1,7
6690     PRINT\" Use  to reposition screen"
6700     PRINT " Use ALT  to resize screen"
6710     PRINT " Use ENTER to accept screen"
6720     PRINT\"  Left: ";scr_hz_off%,"   Top: ";scr_vt_off%\" Width: ";scr_width%,"Height: ";scr_depth%;
6730     AT 0,0
6740     key = Key_from_Keybd
6750     IF key = ENTER% : key_bffr$ = "" : EXIT chg_scrn
6760     IF key < 128    : NEXT chg_scrn
6770     SELect ON key
6780       = lf_arrow% : IF scr_hz_off% > wd_pix% : scr_hz_off% = scr_hz_off% - wd_pix%
6790       = rt_arrow% : IF scr_hz_off% + scr_width%*wd_pix% <= max_wide%-wd_pix% : scr_hz_off% = scr_hz_off% + wd_pix%
6800       = up_arrow% : IF scr_vt_off% > hi_pix% DIV 2 : scr_vt_off% = scr_vt_off% - hi_pix% DIV 2
6810       = dn_arrow% : IF hi_pix% DIV 2 + scr_vt_off% + scr_depth%*hi_pix% <= max_deep%-hi_pix% : scr_vt_off% = scr_vt_off% + hi_pix% DIV 2
6820       = lf_alt%   : IF scr_width% > min_width% : scr_width% = scr_width% - 1
6830       = rt_alt%   : IF scr_hz_off% + scr_width%*wd_pix% <= max_wide%-wd_pix% : scr_width% = scr_width%+1
6840       = scroll_up%: IF scr_depth% > min_depth% : scr_depth% = scr_depth% - 1
6850       = scroll_dn%: IF scr_vt_off% + scr_depth%*hi_pix% <= max_deep%-(hi_pix%*2) : scr_depth% = scr_depth%+1
6860     END SELect 
6870     BORDER 1,0
6880   END REPeat chg_scrn
6890   REMark scr_depth%  = scr_depth% - 1
6900   REMark scr_vt_adj% = scr_depth% - 1
6910   REMark scr_hz_adj% = (scr_width% * 3) DIV 4
6920 END DEFine 
6930 :
6940 DEFine PROCedure Announce
6950   MODE 4 : WINDOW ScreenWidth%,ScreenHeight%,0,0 : PAPER 0 : CLS
6960   PAPER 2 : INK 7
6970   WINDOW 180,132,ScreenWidth% DIV 2 - 90, ScreenHeight% DIV 2 - 66 : BORDER 1,7 : CLS : PRINT
6980   CSIZE 3,1 :PRINT "  EDITOR"\"   2000"
6990   CSIZE 0,0 :PRINT \"    Screen text editor"
7000   PRINT "       Configurator"\"       version ";vers$
7010   PRINT "    Chas Dillon  1986"\"    Mark Knight  2000"\\" Press any key to continue ";
7020   CURSOR_ON : key_bffr$ = "" : key = Key_from_Keybd
7030 END DEFine 
7040 :
7050 DEFine PROCedure Display_Error
7060   LOCal err_txt$(30), ii
7070   ii = Wrong%
7080   SELect ON ii
7090     = err_syn% : err_txt$ = "Syntax error"
7100     = err_cab% : err_txt$ = "Command abandoned"
7110     = err_nex% : err_txt$ = "Number expected"
7120     = err_tex% : err_txt$ = "Text expected"
7130     = err_ltl% : err_txt$ = "Line too long"
7140     = err_fnf% : err_txt$ = "File not found"
7150     = err_cof% : err_txt$ = "Can't open file"
7160     = err_oom% : err_txt$ = "Out of memory"
7170     = err_ntb% : err_txt$ = "Number too big"
7180     = err_nts% : err_txt$ = "Number too small"
7190     = err_msp% : err_txt$ = "Make space on device"
7200     = err_bfn% : err_txt$ = "Bad file name"
7210     = err_nef% : err_txt$ = "Not EDITOR 2000 file or wrong version"
7220     = err_oor% : err_txt$ = "Out of range"
7230     = err_wrv% : err_txt$ = "Wrong EDITOR version"
7240     END SELect 
7250   Reset_Error_Window
7260   PRINT TO 20;err_txt$; : CLS 4
7270   Reset_Main_Window : AT lin%,col%
7280   key_bffr$ = ""
7290   REPeat drain : IF NOT LEN(INKEY$(#1,0)) : EXIT drain
7300 END DEFine 
7310 :
7320 DEFine FuNction Input_Length(chn%)
7330   LOCal x
7340   SET_POSITION #(chn%), 2E6 : x = POSITION(#(chn%))
7350   SET_POSITION #(chn%), 0 : RETurn x
7360 END DEFine 
7370 :
7380 DEFine PROCedure Calc_Text_Limits
7390   txt_width% = width% - (LEN(msg$) MOD width%)
7400   txt_max_ch% = txt_width% * depth% - 2
7410   IF txt_max_ch% > max_ch% : txt_max_ch% = max_ch%
7420   IF LEN(ip_str$) > txt_max_ch% : ip_str$ = ip_str$(1 TO txt_max_ch%)
7430   txt_lines% = 1 + (LEN(ip_str$) DIV txt_width%)
7440   Reset_Command_Window
7450 END DEFine 
7460 :
7470 DEFine FuNction Text_Response$(str$,msg$)
7480   LOCal x$(2), ii, ptr%
7490   LOCal Moved%
7500   ip_str$ = str$
7510   Calc_Text_Limits
7520   txt_lin% = 0 : txt_ptr% = 0 : ptr% = 0
7530   AT txt_lin%, ptr% : CURSOR_ON #1!
7540   Moved%=FALSE%
7550   REPeat ip_edit_lp
7560     ii = Key_from_Keybd : x$ = CHR$(ii)
7570     SELect ON ii
7580       = up_arrow%, lf_alt% : ptr% = 0 : Posn_Txt_Cursor
7590       = dn_arrow%, rt_alt% : ptr% = LEN(ip_str$) : Posn_Txt_Cursor : Moved% = TRUE%
7600       = lf_arrow%  : IF ptr%>0
7610                        ptr% = ptr%-1 : Posn_Txt_Cursor : Moved% = TRUE% : END IF 
7620       = rt_arrow%  : IF ptr% < LEN(ip_str$)
7630                        ptr% = ptr%+1 : Posn_Txt_Cursor : Moved% = TRUE% : END IF 
7640       = ENTER%     : EXIT ip_edit_lp
7650       = del_lf%    : Delete_Char (TRUE%)
7660       = del_rt%    : Delete_Char (FALSE%)
7670       = del_stol%  : IF ptr%
7680                        Moved% = TRUE%
7690                        IF ptr%<LEN(ip_str$)
7700                          ip_str$ = ip_str$(ptr%+1 TO LEN(ip_str$)): ptr%=0
7710                          ELSE : ip_str$ = "": ptr% = 0 : END IF 
7720                        Show_Resp : END IF 
7730       = del_ndol%  : IF ptr%<LEN(ip_str$)
7740                        Moved% = TRUE%
7750                        IF ptr%
7760                          ip_str$ = ip_str$(array_base% TO ptr%) : ptr% = LEN(ip_str$)
7770                          ELSE : ip_str$ = "": ptr% = 0 :END IF 
7780                        Show_Resp : END IF 
7790       = 32 TO 191
7800         IF ip_str$=str$ AND ptr%=0 AND Moved%=FALSE% THEN 
7810           ip_str$=""
7820           Add_Char (FALSE%)
7830         ELSE 
7840           Add_Char (FALSE%)
7850         END IF 
7860         Moved% = TRUE%
7870     END SELect 
7880   END REPeat ip_edit_lp
7890   Reset_Main_Window
7900   RETurn ip_str$
7910 END DEFine 
7920 :
7930 DEFine PROCedure Add_Char(check_it)
7940   IF ptr% = 0 AND check_it : RETurn 
7950   IF LEN(ip_str$) >= txt_max_ch% : RETurn 
7960   IF ptr% = LEN(ip_str$)
7970     ip_str$ = ip_str$ & x$ : ELSE 
7980     IF ptr% = 0
7990       ip_str$ = x$ & ip_str$ : ELSE 
8000       ip_str$ = ip_str$(array_base% TO ptr%) & x$ & ip_str$(ptr%+1 TO LEN(ip_str$))
8010     END IF : END IF 
8020   ptr% = ptr%+1
8030   Show_Resp
8040 END DEFine 
8050 :
8060 DEFine PROCedure Delete_Char(char_on_left)
8070 LOCal a$(txt_max_ch%)
8080   IF LEN(ip_str$) = 0 : RETurn 
8090   IF char_on_left
8100     IF ptr% = 0   : RETurn 
8110     IF LEN(ip_str$) = array_base%
8120       ip_str$ = "" : ELSE 
8130       IF ptr% = LEN(ip_str$)
8140         ip_str$  = ip_str$(array_base% TO LEN(ip_str$)-1) : ELSE 
8150         IF ptr%-1 : a$ = ip_str$(array_base% TO ptr%-1) : ELSE : a$=""
8160         ip_str$ = a$ & ip_str$(ptr%+1 TO LEN(ip_str$))
8170       END IF : END IF 
8180     ptr% = ptr% -1
8190   ELSE 
8200     IF ptr%=LEN(ip_str$) : RETurn 
8210     IF LEN(ip_str$) = array_base%
8220       ip_str$ = "" : ELSE 
8230       IF ptr% = 0
8240         ip_str$ = ip_str$(array_base% + 1 TO LEN(ip_str$)) : ELSE 
8250         IF ptr%+1=LEN(ip_str$) : a$="" : ELSE : a$ = ip_str$(ptr%+2 TO LEN(ip_str$))
8260         ip_str$ = ip_str$(array_base% TO ptr%) & a$
8270       END IF : END IF 
8280   END IF 
8290   Moved% = TRUE%
8300   Show_Resp
8310 END DEFine 
8320 :
8330 DEFine PROCedure Show_Resp
8340 LOCal tmp%
8350   CURSOR_OFF
8360   tmp% = LEN(ip_str$) DIV txt_width%  + 1
8370   IF tmp% > txt_lines%
8380     txt_lines% = tmp%
8390     Reset_Command_Window
8400     ELSE 
8410     REPeat clr_below
8420       IF tmp% = txt_lines% : EXIT clr_below
8430       AT tmp%, 0 : CLS 4 : tmp% = tmp% + 1
8440       END REPeat clr_below
8450     AT 0,0 : PRINT ip_str$; : CLS 4 : CLS 2
8460     END IF 
8470   Posn_Txt_Cursor
8480   END DEFine 
8490 :
8500 DEFine PROCedure Posn_Txt_Cursor
8510 LOCal txt_lin%, txt_ptr%
8520   txt_lin% = ptr% DIV txt_width%
8530   txt_ptr% = ptr% MOD txt_width%
8540   AT txt_lin%, txt_ptr% : CURSOR_ON #1!
8550   END DEFine 
8560 :
8570 DEFine FuNction File_not_Available% (chn%, str$, for_output, space_needed)
8580   LOCal x, free_capacity
8590   IF LEN(str$) = 0 OR LEN(str$) > 36+6 : RETurn err_bfn%
8600   IF NOT for_output
8610     IF "neto" INSTR str$ = 1 : RETurn err_bfn%
8620     ELSE 
8630     IF "neti" INSTR str$ = 1 : RETurn err_bfn%
8640     END IF 
8650   REMark directory_device% = TRUE%
8660   IF for_output : x = 2 : ELSE : x = 1
8670   x = DEVICE_STATUS((x), (str$))
8680   REMark IF x = 65535 * 512 : directory_device% = FALSE%
8690   IF NOT for_output
8700     IF x >= 0
8710       OPEN_IN #(chn%), (str$) : RETurn FALSE%
8720       ELSE : RETurn err_fnf% : END IF 
8730     END IF 
8740   IF x = -8
8750     IF DEVICE_STATUS(2,str$&CHR$(0))<0 : RETurn err_cof%
8760     yn$ = Text_Response$("","Overwrite "&str$&" (y/n): ")
8770     IF Wrong% OR yn$ == "n" : RETurn err_cab%
8780     free_capacity = DEVICE_STATUS(0,(str$))
8790     OPEN_IN #chn%, str$
8800     free_capacity = free_capacity + Input_Length((chn%))
8810     CLOSE #chn%
8820     ELSE 
8830     IF x < 0 : RETurn err_cof%
8840     free_capacity = x
8850     END IF 
8860   IF free_capacity < space_needed : RETurn err_msp%
8870   REMark IF x = -8 : DELETE (str$)
8880   REMark OPEN_NEW #(chn%), (str$)
8890   RETurn FALSE%
8900 END DEFine 
8910 :
8920 REMark - MK - Code below uses binary chop to find screen size - very quick.
8930 :
8940 DEFine PROCedure Find_SCREENSIZE
8950   LOCal ChopLoop
8960   LOCal top%,btm%,diff%
8970   ScreenWidth%=512
8980   top% = 4096
8990   btm% = 512
9000   diff% = top% - btm%
9010   IF NOT(FWINDOW%(#1,ScreenWidth%,10,0,0)>-1 AND FWINDOW%(#1,ScreenWidth%+2,10,0,0)<0) THEN 
9020     REPeat ChopLoop
9030       IF FWINDOW%(#1,ScreenWidth%,10,0,0)<0 THEN 
9040         REMark - MK - too wide, make it narrower.
9050         ScreenWidth% = ScreenWidth%-diff%
9060         diff% = diff% DIV 2
9070       END IF 
9080       IF FWINDOW%(#1,ScreenWidth%+2,10,0,0)>-1 THEN 
9090         REMark - MK - too narrow, make it wider.
9100         ScreenWidth% = ScreenWidth% + diff%
9110         diff% = diff% DIV 2
9120       END IF 
9130       IF diff% < 2 THEN diff% = 2
9140       ScreenWidth% = ScreenWidth% && -2 :REMark - MK - Make sure its even
9150       IF FWINDOW%(#1,ScreenWidth%,10,0,0)>-1 AND FWINDOW%(#1,ScreenWidth%+2,10,0,0)<0 THEN EXIT ChopLoop
9160     END REPeat ChopLoop
9170   END IF 
9180   top%  = 3072
9190   btm%  = 256
9200   diff% = top% - btm%
9210   ScreenHeight% = 256
9220   IF NOT(FWINDOW%(#1,10,ScreenHeight%,0,0)>-1 AND FWINDOW%(#1,10,ScreenHeight%+2,0,0)<0) THEN 
9230     REPeat ChopLoop
9240       IF FWINDOW%(#1,10,ScreenHeight%,0,0)<0 THEN 
9250         REMark - MK - too high, make it lower.
9260         ScreenHeight% = ScreenHeight%-diff%
9270         diff% = diff% DIV 2
9280       END IF 
9290       IF FWINDOW%(#1,10,ScreenHeight%+1,0,0)>-1
9300         REMark - MK - too low, make it higher.
9310         ScreenHeight% = ScreenHeight%+diff%
9320         diff% = diff% DIV 2
9330       END IF 
9340       IF diff% < 2 THEN diff% = 2
9350       ScreenHeight% = ScreenHeight% && -2 :REMark - MK - make sure its even.
9360       IF FWINDOW%(#1,10,ScreenHeight%,0,0)>-1 AND FWINDOW%(#1,10,ScreenHeight%+2,0,0)<0 THEN EXIT ChopLoop
9370     END REPeat ChopLoop
9380   END IF 
9390   REMark WINDOW#1;100,100,ScreenWidth% DIV 2 - 50,ScreenHeight% DIV 2 - 50
9400 END DEFine Find_SCREENSIZE
9410 :
9420 REMark - MK - startup code calls this to ensure the configured WINDOWs fit
9430 REMark        on the currently available screen area, if not then it sets
9440 REMark        built-in defaults that fit on a standard QL 512x256 screen
9450 :
9460 DEFine PROCedure Check_BOUNDS
9470   LOCal ii
9480   scr_hz_pixels% = wd_pix% * scr_width%
9490   scr_vt_pixels% = hi_pix% * scr_depth%
9500   ii=FWINDOW%(#1,scr_hz_pixels%+4,scr_vt_pixels%+12,scr_hz_off%-2,scr_vt_off%-1)
9510   IF ii<0 THEN 
9520     REMark window won't fit so...
9530     scr_depth%  = 24
9540     scr_width%  = 84
9550     wd_pix%     =  6
9560     hi_pix%     = 10
9570     scr_vt_off% =  1
9580     scr_hz_off% =  2
9590     scr_mode%   =  4
9600     REMark ...now it will fit on any screen
9610   END IF 
9620 END DEFine Check_BOUNDS
9630 :
9640 DEFine PROCedure Find_VERSION
9650   LOCal Test$(6)
9660   SET_POSITION#3;10
9670   Test$=INPUT$(#3,6)
9680   IF Test$<>"Editor"
9690     Wrong%=err_nef%
9700     RETurn 
9710   END IF 
9720   SET_POSITION#3;17
9730   Test$=INPUT$(#3,5)
9740   Test$(2)="."
9750   IF Test$<>"3.06K" THEN 
9760     Wrong%=err_wrv%
9770     RETurn 
9780   END IF 
9790 END DEFine 
9800 :
